<template>
  <section class="section">
    <div class="columns is-centered">
      <div class="column is-half content">
        <p>Projects provide logical groupings of services and users that will appear on a single bill for that project.</p>
        <p>Get started by entering a name for your project below. Names do not have to be unique but we recommend that they are.</p>
        <p class="has-text-weight-semibold">Creating a project incurs no additional costs.</p>
        <form>
          <div class="field has-addons">
            <div class="control is-expanded">
              <input
                class="input"
                type="text"
                v-model="projectName"
                placeholder="Name of project"
                required
              />
            </div>
            <div class="control">
              <a class="button is-info" v-on:click="createProject">Create Project</a>
            </div>
          </div>
        </form>
      </div>
    </div>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import { Project } from "../services/arbalo_extensions/projects";
import { MessageLevel } from "../store/types";

@Component
export default class DashboardAddProject extends Vue {
  projectName = "";

  createProject() {
    try {
      this.$store.dispatch("project/createProject", {
        project: { id: 0, uuid: "", title: this.projectName, slug: "" }
      });
      this.$store.commit("setMessage", {
        level: MessageLevel.Success,
        header: "Success",
        body: "Your project has been created"
      });

    } catch (error) {
      console.error(error);
      this.$store.commit(
        "setErrorMessage",
        "Something went wrong when trying to create your project - Sorry!"
      );
    }

    this.$router.push({
      name: "dashboard-project",
      params: { projectUUID: this.$store.state.activeProject.uuid }
    });
  }
}
</script>

<style lang="scss" scoped>
</style>
